/* WatchDog 1.3 */
call RxFuncAdd 'ProcList', 'RXPROCSS', 'ProcList'
call RxFuncAdd 'SysSleep', 'RexxUtil', 'SysSleep'

KeepListName = 'keep.me'
LogName = 'watchdog.log'
ID = 'Watchdog 1.3'
Timeout = 6 /* like this numder :) */
KeepList.0=0
KeepList_.0=0
mydir = directory()

call on halt name BreakDog

say  ID' started'
call LogItem '*** Event: '||ID||' started.'

call checkconfig

call checktasks

   if rec = 0 then
   do forever
     KeepList_.0 = KeepList.0; do i=1 to KeepList.0; KeepList_.i = KeepList.i; end
     call ProcList 'PROCESS'
     DO t=1 to process.0 /* list */
        do i = 1 to KeepList_.0 /* scan list of keeped processes */
        if pos( word(KeepList_.i,1),word(PROCESS.t,2) ) <> 0 then /* OK, we found process, his name no more needed */
           do
                do j = i to KeepList_.0 - 1
                KeepList_.j = Value('KeepList_.'||Value(j+1))
                end
           KeepList_.0 = KeepList_.0 - 1
           end
         end /* scan list of keeped processes */
     END /* scan PROCESS */

        do j = 1 to KeepList_.0
        curdir = directory(word(KeepList_.j, 2)) 
        if translate(curdir) = translate(word(KeepList_.j, 2)) then /* if path succefully changed then */
          do 
								 /* start task */
          '@'subword(KeepList_.j, 3)
								 /* ... and log result */
          if rc=0 then
             call LogItem '*** Event: '||word(KeepList_.j,1)||' restarted. RC='rc
          else
		   call LogItem '*** Error: '||word(KeepList_.j,1)||' execution error. RC='rc
          end
        else						/* otherwise log error path */
              call LogItem '*** Error: Path "'||word(KeepList_.j, 2)||'" does not exist'
        curdir = directory (mydir)
        end

				/* let system work */
  call SysSleep TimeOut
  if stream(mydir||'\.re-read','c','query exists')<>'' then
     do
     /* delete semaphore */
     '@del 'mydir'\.re-read 2>nul 1>nul' 
     call checkconfig
     call LogItem '*** Event: Config re-readed by semaphore signal.'
	call checktasks
     end   /* if stream re-read exists... */

  end /* do forever */
   else
     say 'Error '||rc

exit



/* -------------- Functions ---------------------- */

 ReadTextFile:
   parse arg fileName

   drop KeepList. /* Reset stem variable - list items may change */

   rc = -1
   if fileName <> "" then
   do
     KeepList.0 = 0
                         /* set the return code 2 - file not found     */
     rc = 2
     if stream( mydir||'\'||fileName, "c", "QUERY EXIST" ) <> "" then
     do
                         /* set return code to 0                       */
       rc = 0
       do i=1 until lines(mydir||'\'||fileName) = 0
       curline = '#'

           do while pos(left(curline, 1),'#;') <> 0
	      curline = linein(mydir||'\'||filename)
           end

       if curline <> '' then KeepList.i =  curline
       end /* until */
                         /* close the file                             */
       call stream fileName, "c", "CLOSE"
                         /* correct the no. of lines in stem.0         */
       KeepList.0 = i

     end /* if stream( ... */

   end /* if fileName <> "" & ... */

 RETURN rc

BreakDog:
call LogItem '*** Event: 'ID' brake signal catched. The end'
exit 0

LogItem:
  parse arg Item
  rc = lineout(mydir||'\'||LogName, Date()||' '||Time()||' '||Item)
  call stream LogName, "c", "CLOSE"
return

checkconfig:
rec = ReadTextFile( KeepListName )
if rec<>0 then 
do
   say 'Error opening KeepList file ('KeepListName'). RC='rec
   call LogItem '*** Error opening KeepList file ('KeepListName'). RC='rec
   exit
end
return


checktasks:
say Keeplist.0' tasks loaded'
if KeepList.0=0 then 
do
   say 'No tasks loaded...'
   call LogItem '*** Warning: No tasks loaded...'
end
return